unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, uCapturableWebBrowser, ExtDlgs, XPMan;

type
  TfrmWebCap = class(TForm)
    pnlControlBase: TPanel;
    edtURL: TLabeledEdit;
    pnlButtonBase: TPanel;
    btnGo: TButton;
    btnPrint: TButton;
    dlgSave: TSavePictureDialog;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure btnGoClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
  private
    FCapturableWebBrowser: TCapturableWebBrowser;
  public
  end;

var
  frmWebCap: TfrmWebCap;

implementation

uses
  OleCtrls;

{$R *.dfm}

procedure TfrmWebCap.btnGoClick(Sender: TObject);
begin
  FCapturableWebBrowser.Navigate(edtURL.Text);
end;

procedure TfrmWebCap.btnPrintClick(Sender: TObject);
var
  Bmp: TBitmap;

  // S̃Rg[ɍĕ`̗\
  procedure Invalidates(const vWC: TWinControl);
  var
    i: Integer;
    C: TControl;
  begin
    for i := 0 to vWC.ControlCount - 1 do begin
      C := vWC.Controls[i];

      if (C is TWinControl) then
        Invalidates(TWinControl(C));
    end;

    vWC.Invalidate;
  end;

begin
  if (not dlgSave.Execute) then
    Exit;

  Perform(WM_SETREDRAW, 0, 0); // EFuLv`BԁAĕ`֎~
  try
    Bmp := TBitmap.Create;
    try
      FCapturableWebBrowser.PaintTo(Bmp);

      Bmp.SaveToFile(dlgSave.FileName);
    finally
      Bmp.Free;
    end;
  finally
    Perform(WM_SETREDRAW, 1, 0); // ĕ`
  end;

  Invalidates(Self);
end;

procedure TfrmWebCap.FormCreate(Sender: TObject);
begin
  FCapturableWebBrowser := TCapturableWebBrowser.Create(Self);

  with FCapturableWebBrowser do begin
    Align := alClient;
    ScrollBars := ssVertical;
    Navigate('about:blank');
  end;

  TOleControl(FCapturableWebBrowser).Parent := Self;
end;

end.
